//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  Registry = new TRegistry();
  RegLoaded = false;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::DoCodeMake(void)
{ //this generates HTML from text and colors
    //TODO: Add your source code here
    AnsiString Txt, Res;
    char *str;
    int len, str_i;
    TColor begc, endc;
    long int bR, bG, bB, eR, eG, eB; //begin and end color components
    long int tekR, tekG, tekB; //color components of a current letter
    int TypeOfCode, TypeOfTag;
    TypeOfCode = CodeType->ItemIndex;
    if (TypeOfCode<0) return;
    TypeOfTag = TagType->ItemIndex;
    if (TypeOfTag<0) return;
    TagType->Enabled = (TypeOfCode != 3);
    Txt = Ish->Text;
    len = Txt.Length();
    if (len<=1)
    {
      Code->Text = "";
      return;
    } //end if
    str = Txt.c_str();
    //let us get color values of begin and end
    begc = ColorBegin->Brush->Color;
    endc = ColorEnd->Brush->Color;
    bR = GetRValue((COLORREF)begc);
    bG = GetGValue((COLORREF)begc);
    bB = GetBValue((COLORREF)begc);
    eR = GetRValue((COLORREF)endc);
    eG = GetGValue((COLORREF)endc);
    eB = GetBValue((COLORREF)endc);
    for (str_i=0; str_i<len; str_i++)
    {
      tekR = bR + (eR-bR)*str_i/(len-1);
      tekG = bG + (eG-bG)*str_i/(len-1);
      tekB = bB + (eB-bB)*str_i/(len-1);
      tekR = tekR & 0xFF;
      switch (TypeOfCode)
      {
      case 0: //HTML with " quotes
       if (TypeOfTag==0)
        Res.sprintf("<font color=\"\#%02x%02x%02x\">%c<\/font>",
          tekR, tekG, tekB, str[str_i]);
       else
        Res.sprintf("<span style=\"color:\#%02x%02x%02x\">%c<\/span>",
          tekR, tekG, tekB, str[str_i]);
       break;
      case 1: //HTML with ' quotes
       if (TypeOfTag==0)
        Res.sprintf("<font color=\'\#%02x%02x%02x\'>%c<\/font>",
          tekR, tekG, tekB, str[str_i]);
       else
        Res.sprintf("<span style=\'color:\#%02x%02x%02x\'>%c<\/span>",
          tekR, tekG, tekB, str[str_i]);
       break;
      case 2: //HTML with no quotes
       if (TypeOfTag==0)
        Res.sprintf("<font color=\#%02x%02x%02x>%c<\/font>",
          tekR, tekG, tekB, str[str_i]);
       else
        Res.sprintf("<span style=color:\#%02x%02x%02x>%c<\/span>",
          tekR, tekG, tekB, str[str_i]);
       break;
      case 3: //BB-code
       Res.sprintf("[color=\#%02x%02x%02x]%c[\/color]",
        tekR, tekG, tekB, str[str_i]);
       break;
      }//end switch
    }//end for str_i
    Code->Text = Res;
    //  
    if (Txt=="")
      Code->Text = "* *  *,   .";
    if (Txt=="")
      Code->Text = "     !";
    if (Txt=="  ")
      Code->Text = "     !";
    if (Txt=="")
      Code->Visible = false;
    if (Txt=="")
      Code->Visible = false;
    if (Txt=="")
      Code->Visible = true;
    if (Txt=="")
      Code->Visible = true;
    if (Txt=="Pizding")
      Code->Text = ",       , "
        "   - ,     .";
    if (Txt=="  ")
    {
      Code->Text = "  -!:)    ! "
        "      .";
      Ish->Visible = false;
    }
}// End of TForm1::DoCodeMake
//---------------------------------------------------------------------------

void __fastcall TForm1::CopyAllCodeClick(TObject *Sender)
{
  //DEBUG: let us check how TForm1::DoCodeMake works
  //DoCodeMake();  //ONLY for debug
  //let us do what TForm1::CopyAllCodeClick must do
  Code->SelectAll();
  Code->CopyToClipboard();  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ColorBeginMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  bool ok;
  ok = ColorDialog1->Execute();
  if (ok)
  {
    ColorBegin->Brush->Color = ColorDialog1->Color;
    DoCodeMake();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ColorEndMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  bool ok;
  ok = ColorDialog1->Execute();
  if (ok)
  {
    ColorEnd->Brush->Color = ColorDialog1->Color;
    DoCodeMake();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  if (Ish->Modified)
  {
    DoCodeMake();
    Ish->Modified = false;
  }//end if Ish->Modified
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonBeginClick(TObject *Sender)
{
  ColorDialog1->Color = ColorBegin->Brush->Color;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonEndClick(TObject *Sender)
{
  ColorDialog1->Color = ColorEnd->Brush->Color;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CodeTypeClick(TObject *Sender)
{
  DoCodeMake();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FaceAndSizeButtonClick(TObject *Sender)
{
  bool ok;
  FontDialog1->Font->Assign(Ish->Font);
  ok = FontDialog1->Execute();
  if (ok)
  {
    Ish->Font->Assign(FontDialog1->Font);
    SaveReg();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FaceAndSizeButton2Click(TObject *Sender)
{
  bool ok;
  FontDialog1->Font->Assign(Code->Font);
  ok = FontDialog1->Execute();
  if (ok)
  {
    Code->Font->Assign(FontDialog1->Font);
    SaveReg();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FontColorButtonClick(TObject *Sender)
{
  bool ok;
  ok = ColorDialog1->Execute();
  if (ok)
  {
    Ish->Font->Color = ColorDialog1->Color;
    SaveReg();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FontColorButton2Click(TObject *Sender)
{
  bool ok;
  ok = ColorDialog1->Execute();
  if (ok)
  {
    Code->Font->Color = ColorDialog1->Color;
    SaveReg();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BGColorButtonClick(TObject *Sender)
{
  bool ok;
  ok = ColorDialog1->Execute();
  if (ok)
  {
    Ish->Color = ColorDialog1->Color;
    SaveReg();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BGColorButton2Click(TObject *Sender)
{
  bool ok;
  ok = ColorDialog1->Execute();
  if (ok)
  {
    Code->Color = ColorDialog1->Color;
    SaveReg();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetDefaultsButtonClick(TObject *Sender)
{
  Ish->Color = clWindow;
  Ish->Font->Color = clWindowText;
  Ish->Font->Name = "MS Sans Serif";
  Ish->Font->Size = 10;
  Ish->Font->Style.Clear();
  SaveReg();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetDefaultsButton2Click(TObject *Sender)
{
  Code->Color = clWindow;
  Code->Font->Color = clWindowText;
  Code->Font->Name = "Courier New";
  Code->Font->Size = 10;
  Code->Font->Style.Clear();
  SaveReg();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::LoadReg(void)
{
    //TODO: Add your source code here
    //ReadBool();
    AnsiString Key;
    bool OkOb=true;
    TColor IshColor, IshFontColor;
    AnsiString IshFontName;
    int IshFontSize;
    bool IshFontStyleBold, IshFontStyleItalic;
    TColor CodeColor, CodeFontColor;
    AnsiString CodeFontName;
    int CodeFontSize;
    bool CodeFontStyleBold, CodeFontStyleItalic;
    Key="Software\\Super-M\\GradientHTML\\";
    if (Registry->KeyExists(Key))
    {
      try
      {
        Registry->OpenKeyReadOnly(Key);
        //let`s read for Ish memo
        if (Registry->ValueExists("IshColor"))
         IshColor=(TColor)Registry->ReadInteger("IshColor");
        if (Registry->ValueExists("IshFontColor"))
         IshFontColor=(TColor)Registry->ReadInteger("IshFontColor");
        if (Registry->ValueExists("IshFontSize"))
         IshFontSize=Registry->ReadInteger("IshFontSize");
        if (Registry->ValueExists("IshFontName"))
         IshFontName=Registry->ReadString("IshFontName");
        if (Registry->ValueExists("IshFontStyleBold"))
         IshFontStyleBold=Registry->ReadBool("IshFontStyleBold");
        if (Registry->ValueExists("IshFontStyleItalic"))
         IshFontStyleItalic=Registry->ReadBool("IshFontStyleItalic");
        //let`s read for Code memo
        if (Registry->ValueExists("CodeColor"))
         CodeColor=(TColor)Registry->ReadInteger("CodeColor");
        if (Registry->ValueExists("CodeFontColor"))
         CodeFontColor=(TColor)Registry->ReadInteger("CodeFontColor");
        if (Registry->ValueExists("CodeFontSize"))
         CodeFontSize=Registry->ReadInteger("CodeFontSize");
        if (Registry->ValueExists("CodeFontName"))
         CodeFontName=Registry->ReadString("CodeFontName");
        if (Registry->ValueExists("CodeFontStyleBold"))
         CodeFontStyleBold=Registry->ReadBool("CodeFontStyleBold");
        if (Registry->ValueExists("CodeFontStyleItalic"))
         CodeFontStyleItalic=Registry->ReadBool("CodeFontStyleItalic");
        Registry->CloseKey(); //close key
      }//end try
      catch(Exception &exception)
      {
        Application->MessageBox(
        "  ?\n ,      \n"
          "    ,     ",
        "   ",
        MB_OK | MB_ICONERROR);
        OkOb=false;
      }//end catch
      if (OkOb)
      {
          Ish->Color = IshColor;
          Ish->Font->Color = IshFontColor;
          Ish->Font->Name = IshFontName;
          Ish->Font->Size = IshFontSize;
          Ish->Font->Style.Clear();
          if (IshFontStyleBold)
            Ish->Font->Style << fsBold;
          if (IshFontStyleItalic)
            Ish->Font->Style << fsItalic;

          Code->Color = CodeColor;
          Code->Font->Color = CodeFontColor;
          Code->Font->Name = CodeFontName;
          Code->Font->Size = CodeFontSize;
          Code->Font->Style.Clear();
          if (CodeFontStyleBold)
            Code->Font->Style << fsBold;
          if (CodeFontStyleItalic)
            Code->Font->Style << fsItalic;
      }//end if OkOb
    }//end of if (Registry->KeyExists(Key))
}//end of TForm1::LoadReg
//--------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  delete Registry;  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
  //
  if (! RegLoaded)
   { LoadReg(); RegLoaded=true; }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SaveReg(void)
{
    //TODO: Add your source code here
    AnsiString Key;
    //bool OkOb=true;
    TColor IshColor, IshFontColor;
    AnsiString IshFontName;
    int IshFontSize;
    bool IshFontStyleBold, IshFontStyleItalic;
    TColor CodeColor, CodeFontColor;
    AnsiString CodeFontName;
    int CodeFontSize;
    bool CodeFontStyleBold, CodeFontStyleItalic;
    Key="Software\\Super-M\\GradientHTML\\";
    //let`s give values to vars

    IshColor = Ish->Color;
    IshFontColor = Ish->Font->Color;
    IshFontName = Ish->Font->Name;
    IshFontSize = Ish->Font->Size;
    IshFontStyleBold = (Ish->Font->Style.Contains(fsBold));
    IshFontStyleItalic = Ish->Font->Style.Contains(fsItalic);

    CodeColor = Code->Color;
    CodeFontColor = Code->Font->Color;
    CodeFontName = Code->Font->Name;
    CodeFontSize = Code->Font->Size;
    CodeFontStyleBold = (Code->Font->Style.Contains(fsBold));
    CodeFontStyleItalic = Code->Font->Style.Contains(fsItalic);

    //now play with registry
    try
    {
      //let`s open key
      Registry->OpenKey(Key,true);
      //writing values for Ish memo
      Registry->WriteInteger("IshColor",
            (int)IshColor);
      Registry->WriteInteger("IshFontColor",
            (int)IshFontColor);
      Registry->WriteInteger("IshFontSize",
            IshFontSize);
      Registry->WriteString("IshFontName",
            IshFontName);
      Registry->WriteBool("IshFontStyleBold",
            IshFontStyleBold);
      Registry->WriteBool("IshFontStyleItalic",
            IshFontStyleItalic);
      //writing values for Code memo
      Registry->WriteInteger("CodeColor",
            (int)CodeColor);
      Registry->WriteInteger("CodeFontColor",
            (int)CodeFontColor);
      Registry->WriteInteger("CodeFontSize",
            CodeFontSize);
      Registry->WriteString("CodeFontName",
            CodeFontName);
      Registry->WriteBool("CodeFontStyleBold",
            CodeFontStyleBold);
      Registry->WriteBool("CodeFontStyleItalic",
            CodeFontStyleItalic);
      //let`s close key
      Registry->CloseKey();
    }//end try
    catch(Exception &exception)
    {
        Application->MessageBox(
        "???",
        "    ",
        MB_OK | MB_ICONERROR);
    }//end catch
}//end of TForm1::SaveReg
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonAboutClick(TObject *Sender)
{
  About->ShowModal();  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TagTypeClick(TObject *Sender)
{
  DoCodeMake();
}
//---------------------------------------------------------------------------

