//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Registry.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
  TGroupBox *GroupBox1;
  TGroupBox *GroupBox2;
  TLabel *Label1;
  TShape *ColorBegin;
  TShape *ColorEnd;
  TColorDialog *ColorDialog1;
  TMemo *Ish;
  TLabel *Label2;
  TTimer *Timer1;
  TMemo *Code;
  TLabel *Label3;
  TButton *CopyAllCode;
  TGroupBox *GroupBox3;
  TButton *ButtonBegin;
  TButton *ButtonEnd;
  TRadioGroup *CodeType;
  TSpeedButton *FaceAndSizeButton;
  TSpeedButton *FontColorButton;
  TSpeedButton *BGColorButton;
  TSpeedButton *SetDefaultsButton;
  TSpeedButton *FaceAndSizeButton2;
  TSpeedButton *FontColorButton2;
  TSpeedButton *BGColorButton2;
  TSpeedButton *SetDefaultsButton2;
  TFontDialog *FontDialog1;
  TButton *ButtonAbout;
  TRadioGroup *TagType;
  void __fastcall CopyAllCodeClick(TObject *Sender);
  void __fastcall ColorBeginMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall ColorEndMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall ButtonBeginClick(TObject *Sender);
  void __fastcall ButtonEndClick(TObject *Sender);
  void __fastcall CodeTypeClick(TObject *Sender);
  void __fastcall FaceAndSizeButtonClick(TObject *Sender);
  void __fastcall FaceAndSizeButton2Click(TObject *Sender);
  void __fastcall FontColorButtonClick(TObject *Sender);
  void __fastcall FontColorButton2Click(TObject *Sender);
  void __fastcall BGColorButtonClick(TObject *Sender);
  void __fastcall BGColorButton2Click(TObject *Sender);
  void __fastcall SetDefaultsButtonClick(TObject *Sender);
  void __fastcall SetDefaultsButton2Click(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall ButtonAboutClick(TObject *Sender);
  void __fastcall TagTypeClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  __fastcall TForm1(TComponent* Owner);
    void __fastcall DoCodeMake(void);
    void __fastcall LoadReg(void);
    TRegistry *Registry;
    bool RegLoaded;
    void __fastcall SaveReg(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
